# Movable Type plugin for filtering duplicate trackback ping.
#
# Release 1.00 (Sep 20, 2006)
#
# This software is provided as-is. You may use it for commercial or 
# personal use. If you distribute it, please keep this notice intact.
#
# Copyright (c) 2005-2006 Yujiro Araki

package MT::Plugin::duplicateTBPingThrottleFilter;
use strict;
use base qw(MT::Plugin);

our $VERSION = '1.00';

my $plugin = MT::Plugin::duplicateTBPingThrottleFilter->new ({
    name => 'Duplicate Trackback Ping Throttle Filter Plugin',
    description => 'Filter duplicate trackback ping to the same entry.',
    doc_link => 'http://www.koikikukan.com/archives/2006/09/20-011111.php',
    author_name => 'Yujiro Araki',
    author_link => 'http://www.koikikukan.com/',
    version => $VERSION
});

MT->add_plugin ($plugin);
MT->add_callback ('TBPingThrottleFilter', 10, $plugin, sub { filter_duplicate_tbping($plugin, @_)});

use MT::TBPing;
use MT::Template::Context;

sub filter_duplicate_tbping {
    my $plugin = shift;
    my ($eh, $app, $tb) = @_;

    my $q = $app->{query};
    my @pings = MT::TBPing->load({tb_id => $tb->id});
    foreach (@pings) {
        if ($_->source_url eq $q->param('url') &&
            $_->title eq $q->param('title') &&
            $_->excerpt eq $q->param('excerpt')) {
             $app->log("Filter duplicate trackback ping from the following URL:" . $q->param('url'));
             return 0;
        }
    }
    return 1;
}

1;
